%global momorel 31

# Our /usr/bin/last is in the SysVInit packae
%define with_last	0

%define FHS_compliant 1

%if %{FHS_compliant}
%define accounting_logdir	/var/account
%else
%define accounting_logdir	/var/log
%endif

Summary: Utilities for monitoring process activities.
Name: psacct
Version: 6.3.2
Release: %{momorel}m
License: GPL
Group: Applications/System
Source0: ftp://ftp.gnu.org/pub/gnu/acct-%{version}.tar.gz
Source1: psacct.init
# This dumb patch breaks FHS 2.2 compliance, so it is disabled now except
# in 7.x builds.  Do not use it in new products.
Patch0: acct-6.3.2-config.patch
Patch1: acct-6.3.2-exit.patch
# Fixes some broken calls to ctime() on 64bit arch's <mharris@redhat.com>
Patch2: psacct-6.3.2-64bit-fixes.patch
Patch3: psacct-6.3.2-hz.patch
Patch4: acct-6.3.2-pts.patch

Buildroot: %{_tmppath}/%{name}-%{version}-root
PreReq: info, chkconfig
BuildRequires: autoconf

# This conflict is to avoid psacct being forced on by old initscripts now that
# we have a proper initscript in place. initscripts 6.55 and later are fixed.
Conflicts: initscripts < 6.55

%description
The psacct package contains several utilities for monitoring process
activities, including ac, lastcomm, accton and sa. The ac command
displays statistics about how long users have been logged on. The
lastcomm command displays information about previous executed
commands. The accton command turns process accounting on or off. The
sa command summarizes information about previously executed
commmands.

%prep
%setup -q -n acct-%{version}

%if ! %{FHS_compliant}
%patch0 -p0 -b .config
%endif
%patch1 -p1 -b .psacct-exit
%patch2 -p0 -b .64bit-fixes
%patch3 -p1 -b .hz
%patch4 -p1 -b .pts

%build
%if ! %{FHS_compliant}
autoconf
%endif

%configure
sed -e "s/\/\* #undef HAVE_LINUX_ACCT_H \*\//#define HAVE_LINUX_ACCT_H/" config.h > config.h.new
mv -f config.h.new config.h
touch texinfo.tex
make

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
mkdir -p %{buildroot}{/sbin,%{_bindir},%{_mandir},%{_sbindir}}
%{makeinstall}

# move accton to /sbin -- leave historical symlink
mv %{buildroot}%{_sbindir}/accton %{buildroot}/sbin/accton
ln -s ../../sbin/accton %{buildroot}%{_sbindir}/accton

gzip -9f %{buildroot}%{_infodir}/*
mkdir -p %{buildroot}%{accounting_logdir}
touch %{buildroot}%{accounting_logdir}/pacct

# Create logrotate config file
mkdir -p %{buildroot}/etc/logrotate.d
cat > %{buildroot}/etc/logrotate.d/psacct <<EOF
# Logrotate file for psacct RPM
 
%{accounting_logdir}/pacct {
prerotate
        %{_sbindir}/accton
endscript
	compress
	notifempty
        daily
	rotate 31
	create 0600 root root
postrotate
        %{_sbindir}/accton %{accounting_logdir}/pacct
endscript
}     
EOF

# Install initscript
mkdir -p %{buildroot}%{_initscriptdir}
install -m 755 %{SOURCE1} %{buildroot}%{_initscriptdir}/psacct

%if ! %{with_last}
rm -f %{buildroot}%{_bindir}/last %{buildroot}%{_mandir}/man1/last.1*
%endif

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post
/sbin/chkconfig --add psacct
/sbin/chkconfig psacct off
# we need this hack to get rid of an old, incorrect accounting info entry.
if [ $1 = 0 ]; then
  test -f /etc/info-dir && {
    grep -v '* accounting: (psacct)' < /etc/info-dir > /etc/info-dir.new
    mv -f /etc/info-dir.new /etc/info-dir
  }
  /sbin/install-info %{_infodir}/accounting.info.gz %{_infodir}/dir --entry="* accounting: (accounting).            The GNU Process Accounting Suite."
fi

%preun
if [ $1 = 0 ]; then
  /sbin/install-info --delete %{_infodir}/accounting.info.gz %{_infodir}/dir --entry="* accounting: (accounting).            The GNU Process Accounting Suite." 2>/dev/null
  /sbin/chkconfig --del psacct
fi

%files
%defattr(-,root,root)
%if %{FHS_compliant}
%dir /var/account
%endif
%{_initscriptdir}/psacct
%attr(0600,root,root)	%config %{accounting_logdir}/pacct
%attr(0644,root,root)	%config(noreplace) /etc/logrotate.d/*
/sbin/accton
%{_sbindir}/accton
%{_sbindir}/sa
%{_sbindir}/dump-utmp
%{_sbindir}/dump-acct
%{_bindir}/ac
%if %{with_last}
%{_bindir}/last
%endif
%{_bindir}/lastcomm
%{_mandir}/man1/ac.1*
%if %{with_last}
%{_mandir}/man1/last.1*
%endif
%{_mandir}/man1/lastcomm.1*
%{_mandir}/man8/sa.8*
%{_mandir}/man8/accton.8*
%{_infodir}/accounting.info*

%changelog
* Thu Feb  10 2005 Toru Hoshina <t@momonga-linux.org>
- (6.3.2-31m)
- version down. sync with FC3.

* Thu Dec 30 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (6.3-5-1m)
- update 6.3.5
- add SuSE sources and patches
- delete gziped part

* Fri Mar 26 2004 Toru Hoshina <t@momonga-linux.org>
- (6.3.2-19m)
- revised spec for rpm 4.2.

* Tue Apr 30 2002 Kenta MURATA <muraken@kondara.org>
- (6.3.2-18k)

* Wed Feb 20 2002 Mitsuru Shimamura <mitsuru@diana.dti.ne.jp>    
- (6.3.2-16k)
- add BuildPreReq: autoconf >= 2.52-8k, automake >= 1.5-8k

* Mon Feb 18 2002 Tsutomu Yasuda <tom@kondara.org>
- (6.3.2-14k)
- updated Source0 URL.

* Wed Jan  9 2002 Shingo Akagaki <dora@kondara.org>
- (6.3.2-12k)
- autoconf 1.5

* Sat Oct  6 2001 Toru Hoshina <t@kondara.org>
- (6.3.2-10k)

* Thu Sep 06 2001 Mike A. Harris <mharris@redhat.com> 6.3.2-9
- Fixed bug (#53307) psacct is enabled by default, and the log files
  are huge, and will fill the disk up very quickly.  logrotate will
  now compress them daily.

* Sat Sep 01 2001 Florian La Roche <Florian.LaRoche@redhat.de> 6.3.2-8
- do not fail for ENOSYS to silently support kernels without
  process accounting

* Sun Aug 26 2001 Mike A. Harris <mharris@redhat.com> 6.3.2-7
- Change spec tag Copyright -> License
- change logrotate to rotate daily, and keep 1 month (31 days) of data

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.

* Mon Feb 02 2001 Helge Deller <hdeller@redhat.de>
- added logrotate file for /var/log/pacct (#24900)

* Wed Oct 25 2000 MATSUDA, Daiki <dyky@df-usa.com>
- modifiled %post and %preun section from .gz to .bz2

* Mon Aug 07 2000 Toru Hoshina <t@kondara.org>
- Kodaraized.

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jun  5 2000 Nalin Dahyabhai <nalin@redhat.com>
- FHS fixes

* Sat May  6 2000 Bill Nottingham <notting@redhat.com>
- fix for new patch

* Thu Feb 03 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 6.3.2

* Mon Apr 05 1999 Preston Brown <pbrown@redhat.com>
- wrap post script with reference count.

* Tue Mar 23 1999 Preston Brown <pbrown@redhat.com>
- install-info sucks.  Still.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 8)

* Thu Mar 18 1999 Bill Nottingham <notting@redhat.com>
- #define HAVE_LINUX_ACCT_H too, so it works. :)

* Sun Aug 16 1998 Jeff Johnson <jbj@redhat.com>
- accton needs to be accessible to /etc/rc.d/init.d/halt

* Fri May 08 1998 Erik Troan <ewt@redhat.com>
- install-info sucks

* Mon Apr 27 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Thu Oct 23 1997 Donnie Barnes <djb@redhat.com>
- updated from 6.2 to 6.3

* Mon Jul 21 1997 Erik Troan <ewt@redhat.com>
- built against glibc
